#include "../keen.h"

// vertically-moving platform (ep3)

#define PLATVERT_MOVE   0
#define PLATVERT_WAIT   1

#define PLATVERT_WAITTIME       150
#define PLATVERT_MOVE_SPD       3

#define PLATVERT_ANIM_RATE      60

#define PLATVERTPUSHAMOUNT      10

void platvert_ai(int o)
{
   if (objects[o].needinit)
   {  // first time initilization
     objects[o].ai.platform.animframe = 0;
     objects[o].ai.platform.animtimer = 0;
     objects[o].ai.platform.movedir = UP;
     objects[o].ai.platform.state = PLATVERT_MOVE;

     objects[o].inhibitfall = 1;
     objects[o].needinit = 0;
     objects[o].canbezapped = 1;
     SetAllCanSupportPlayer(o, 1);
       objects[o].ai.platform.kickedplayer = 0;
   }

   // after kicking a player, wait until he falls beneath the platform
   // before turning cansupportplayer back on...just in case we also
   // check for if he stopped falling

     if (objects[o].ai.platform.kickedplayer)
     {
       if (player.y > objects[o].y || (!player.pfalling && !player.pjumping))
       {
         objects[o].cansupportplayer = 1;
         objects[o].ai.platform.kickedplayer = 0;
       }
     }


   // push player horizontally
   if (objects[o].touchPlayer && !player.pdie && player.psupportingobject!=o)
   {
     if (objects[o].cansupportplayer)
     {
         // if player is standing around minding his own business and we
         // come down on his head, change direction. if player is trying
         // to walk/jump into us horizontally, push him away.
         if (player.y > objects[o].y && \
              (player.pjumping==PNOJUMP || \
               player.pjumping==PPREPAREJUMP ||\
               player.pjumping==PPREPAREPOGO) &&\
             objects[o].ai.platform.movedir==DOWN &&\
             !player.pfalling)
         {
            // change direction
             objects[o].ai.platform.movedir = UP;
         }
         else
         {
           // push him away  
            if (player.x < objects[o].x)
            {
               player.playpushed_x = -PLATVERTPUSHAMOUNT;
               if (player.pinertia_x > 0) player.pinertia_x = 0;
               player.playpushed_decreasetimer = 0;
            }
            else
            {
               player.playpushed_x = PLATVERTPUSHAMOUNT;
               if (player.pinertia_x < 0) player.pinertia_x = 0;
               player.playpushed_decreasetimer = 0;
            }
         }
     }
   }

   objects[o].sprite = OBJ_PLATFORM_DEFSPRITE_EP3 + objects[o].ai.platform.animframe;

   if (objects[o].ai.platform.animtimer > PLATVERT_ANIM_RATE)
   {
     objects[o].ai.platform.animframe ^= 1;
     objects[o].ai.platform.animtimer = 0;
   }
   else objects[o].ai.platform.animtimer++;

   switch(objects[o].ai.platform.state)
   {
   case PLATVERT_MOVE:

       if (objects[o].ai.platform.movedir==UP)
       {
         if (objects[o].blockedu)
         {
           objects[o].ai.platform.movedir = DOWN;
           objects[o].ai.platform.waittimer = 0;
           objects[o].ai.platform.state = PLATVERT_WAIT;
         }
         else
         {
           objects[o].y -= PLATVERT_MOVE_SPD;
              if(player.psupportingobject==o && (player.pjumping==PNOJUMP||player.pjumping==PPREPAREJUMP||player.pjumping==PPREPAREPOGO))
              {
                  if (!objects[o].ai.platform.kickedplayer)
                  {
                    player.y -= PLATVERT_MOVE_SPD;
                  }
                  // kick player off if we're running him into the ceiling
                  if (player.blockedu)
                  {
                     objects[o].cansupportplayer = 0;
                     objects[o].ai.platform.kickedplayer = 1;
                  }
			  }
         }
       }
       else if (objects[o].ai.platform.movedir==DOWN)
       {
         if (objects[o].blockedd)
         {
           objects[o].ai.platform.movedir = UP;
         }
         else
         {
           objects[o].y += PLATVERT_MOVE_SPD;
              if(player.psupportingobject==o && (player.pjumping==PNOJUMP||player.pjumping==PPREPAREJUMP||player.pjumping==PPREPAREPOGO))
              {
                  if (!objects[o].ai.platform.kickedplayer)
                    player.y += PLATVERT_MOVE_SPD;
              }
         }
       }
   break;
   case PLATVERT_WAIT:
       if (objects[o].ai.platform.waittimer > PLATVERT_WAITTIME)
       {
          objects[o].ai.platform.state = PLATVERT_MOVE;
       }
       else objects[o].ai.platform.waittimer++;
   break;
   }
}
