/* GAMEPDO.C
  Contains all of the gamepdo_xxx functions...which are called from the
  main game loop. These functions perform some task that is done each
  time around the game loop and is related to the player.
*/

char tempbuf[200];

#include "keen.h"

// player handler mother-function, calls all needed "gamepdo" functions
void gamepdo_HandlePlayer()
{
char doFall;

    if (player.pdie)
    {
       gamepdo_dieanim();
       if (!levelcontrol.gameovermode)
       {
         gamepdo_StatusBox();
       }
    }
    else
    {
       if (!levelcontrol.gameovermode)
       {
          player.inhibitwalking = 0;
          player.inhibitfall = 0;

          gamepdo_StatusBox();

          gamepdo_ProcessInput();
          gamepdo_setdir();

          gamepdo_setblockedlru();
          gamepdo_getgoodies();

          if (levelcontrol.episode==3) gamepdo_ankh();

          gamepdo_raygun();

          gamepdo_keencicle();

          gamepdo_walking();
          gamepdo_walkinganim();

          if (fade.mode==NO_FADE || fade.dir==FADE_IN || demomode)
          {
            gamepdo_playpushed();
            gamepdo_InertiaAndFriction_X();
          }

          gamepdo_JumpAndPogo();

          // decide if player should fall
          doFall = 1;
          if (player.inhibitfall) doFall = 0;
          //else if (immediate_keytable[KF2] && options[OPT_CHEATS].value) doFall = 0;

          if (doFall)
          {             
             gamepdo_falling();
          }
          else
          {
             player.pfalling = 0;
             player.psupportingtile = 145;
             player.psupportingobject = 0;
          }

       }
       else
       { // we're in game-over mode
         
       }
    }

    gamepdo_SelectFrame();

    // copy player's keytable to lastkeytable
    memcpy(&player.lastkeytable, &player.keytable, sizeof(player.lastkeytable));
	player.alreadyPogo = player.isPogo;
}

void gamepdo_walkbehindexitdoor()
{
int x, diff, width;

    /* don't draw keen as he walks through the door (past exitXpos) */
    // X pixel position of right side of player
    x = (player.x >> CSF) + PLAYERSPRITE_WIDTH;
    diff = (x - levelcontrol.exitXpos);        // dist between keen and door
    if (diff >= 0)                             // past exitXpos?
    {
       width = (PLAYERSPRITE_WIDTH - diff);    // get new width of sprite
       if (width < 0) width = 0;               // don't set to negative

       // set new width of all player walk frames
       sprites[playerbaseframe+0].xsize = width;
       sprites[playerbaseframe+1].xsize = width;
       sprites[playerbaseframe+2].xsize = width;
       sprites[playerbaseframe+3].xsize = width;
    }
}

void gamepdo_dieanim()
{
   if (!player.pdie) return;                // should never happen...
   if (player.pdie==PDIE_DEAD) return;      // if true animation is over
   if (player.pdie==PDIE_FELLOFFMAP)
   {
     // wait for falling sound to complete, then kill the player
     if (!sound_is_playing(SOUND_KEEN_FALL))
     {
        player.pdie = 0;
        killplayer();
     }
     else return;
   }

   // peridocally toggle dying animation frame
   if (player.pdietimer > DIE_ANIM_RATE)
   {
     player.pdieframe = 1 - player.pdieframe;
     player.pdietimer = 0;
   }
   else player.pdietimer++;

   // is it time to start flying off the screen?
   if (!player.pdietillfly)
   {  // time to fly off the screen
     if (((player.y>>CSF)+96 > scroll_y) && (player.y>(16<<CSF)))
     {  // player has not reached top of screen
        // make player fly up
        player.y += PDIE_RISE_SPEED;
        if (player.x > (4<<CSF))
        {
          player.x += player.pdie_xvect;
        }
     }
     else
     {  // reached top of screen. he's done.
       player.pdie = PDIE_DEAD;
       if (player.inventory.lives<0)
       {
         SetGameOver();
       }
       else
       {
         endlevel(0);
       }
     }
   }
   else
   {  // not yet time to fly off screen, decrement timer
     player.pdietillfly--;
   }  // end "time to fly"

}

void gamepdo_keencicle()
{
   // keencicle code (when keen gets hit by an ice chunk)
   if (player.pfrozentime)
   {
     if (player.pfrozentime > PFROZEN_THAW)
     {
        if (player.pfrozenanimtimer > PFROZENANIMTIME)
        {
          if (player.pfrozenframe) player.pfrozenframe=0; else player.pfrozenframe=1;
          player.pfrozenanimtimer = 0;
        }
        else player.pfrozenanimtimer++;
     }
     else
     { // thawing out, show the thaw frame
        if (levelcontrol.episode==3)
          player.pfrozenframe = 2;
        else
          player.pfrozenframe = 3;
     }

     player.pfrozentime--;
     player.inhibitwalking = 1;
   }

}

// maps LEFTARROW/RIGHTARROW to LEFT and RIGHT,
// and maps CTRL and ALT to JUMP/POGO/FIRE.
// forces the RIGHT key if we're doing the walk-out-the-exit thing
void gamepdo_ProcessInput()
{
   // are we doing the keen-walking-through-exit door animation?
   if (levelcontrol.level_done)
   {
     // don't let player control keen
     player.keytable[KJUMP] = 0;
     player.keytable[KPOGO] = 0;
	 player.isJump = 0;
	 player.isPogo = 0;
     player.keytable[KFIRE] = 0;
     player.keytable[KLEFT] = 0;
     player.inhibitfall = 1;
     if (levelcontrol.level_done==LEVEL_DONE_WALK)
     {
        // keep him going right
        player.pdir = player.pshowdir = RIGHT;
        // make keen walk slowly through the exit door
        player.keytable[KRIGHT] = 1;
        if (player.pinertia_x > PMAXEXITDOORSPEED)
        {
          player.pinertia_x = PMAXEXITDOORSPEED;
        }
     }
     else
     {
        // he's all the way through the door; hold him still
        player.keytable[KRIGHT] = 0;
        player.pinertia_x = 0;
        player.pwalking = 0;
     }

     if (levelcontrol.level_done_timer > LEVEL_DONE_TOTAL_WAIT_TIME)
     {
       if (levelcontrol.level_done != LEVEL_DONE_FADEOUT)
       {
         levelcontrol.level_done = LEVEL_DONE_FADEOUT;
         endlevel(1);
       }
     }
     else if (levelcontrol.level_done_timer > LEVEL_DONE_STOPWALKING_TIME)
     {
       levelcontrol.level_done = LEVEL_DONE_WAIT;
     }

     levelcontrol.level_done_timer++;
     return;
   }

   #define KPROC_IDLE                   0
   #define KPROC_CTRLDEBOUNCE           1
   #define KPROC_ALTDEBOUNCE            2
   #define KPROC_INFIRESTATE            3
   #define KPROC_WAITALLKEYSRELEASED    4
   #define KPROC_WAITCTRLRELEASED       5
   #define KPROC_WAITALTRELEASED        6

kreproc: ;
   switch(player.keyprocstate)
   {
   case KPROC_IDLE:     // idle--waiting for ctrl or alt to be pushed
     player.isJump = 0;
     player.isPogo = 0;
	 player.keytable[KFIRE] = 0;
	 
	 if (options[OPT_ONEBUTTONFIRE].value && immediate_keytable[KOBF])
	 {
		 player.keyprocstate = KPROC_INFIRESTATE;
		 goto kreproc;
	 }

     if (player.keytable[KPOGO])
     {
       player.keyprocstate = KPROC_ALTDEBOUNCE;
       player.alttimer = 0;
     }
     else if (player.keytable[KJUMP])
     {
       player.keyprocstate = KPROC_CTRLDEBOUNCE;
       player.ctrltimer = 0;
     }
   break;

   case KPROC_CTRLDEBOUNCE:
   // ctrl was pressed--give some debounce time to see if player's going
   // for a fire
      if (player.keytable[KJUMP] && player.keytable[KPOGO] && !options[OPT_ONEBUTTONFIRE].value)
      { // he's going for a fire
         player.keyprocstate = KPROC_INFIRESTATE;
         goto kreproc;
      }
      else if (!player.keytable[KJUMP])
      { // he let go of ctrl before the debounce time, it's a jump
         player.isJump = 1;
         player.keyprocstate = KPROC_WAITCTRLRELEASED;
      }
      else
      { // ctrl is down, alt is not...keep incing the debounce timer...
         if (player.ctrltimer >= CTRLALT_DEBOUNCETIME)
         {
            player.isJump = 1;
            player.keyprocstate = KPROC_WAITCTRLRELEASED;
         }
         else
         { // have not reached max debounce time
            player.ctrltimer++;
         }
      }
   break;

   case KPROC_ALTDEBOUNCE:
   // alt was pressed--give some debounce time to see if player's going
   // for a fire
      if (player.keytable[KJUMP] && player.keytable[KPOGO] && !options[OPT_ONEBUTTONFIRE].value)
      { // he's going for a fire
			player.keyprocstate = KPROC_INFIRESTATE;
			goto kreproc;
      }
      else if (!player.keytable[KPOGO])
      { // he let go of alt before the debounce time, it's a pogo
         player.isPogo = 1;
         player.keyprocstate = KPROC_WAITALTRELEASED;
      }
      else
      { // alt is down, ctrl is not...keep incing the debounce timer...
         if (player.alttimer >= CTRLALT_DEBOUNCETIME)
         {
            player.isPogo = 1;
            player.keyprocstate = KPROC_WAITALTRELEASED;
         }
         else
         { // have not reached max debounce time
            player.alttimer++;
         }
      }
   break;

   case KPROC_INFIRESTATE:
   {
	   int firing = 0;

	   if (!(options[OPT_ONEBUTTONFIRE].value) && immediate_keytable[KJUMP] && immediate_keytable[KPOGO])
		   firing = 1;
	   if ((options[OPT_ONEBUTTONFIRE].value) && immediate_keytable[KOBF])
		   firing = 1;
	   
	   if (firing)
	   {
		   player.keytable[KFIRE] = 1;
	   }
	   else
	   {
		   player.keytable[KFIRE] = 0;
		   player.keyprocstate = KPROC_WAITALLKEYSRELEASED;
	   }
   }
   break;

   case KPROC_WAITALLKEYSRELEASED:
   // wait for both CTRL and ALT released
      if (!player.keytable[KJUMP] && !player.keytable[KPOGO])
      {
         player.ctrltimer = 0;
         player.alttimer = 0;
         player.keyprocstate = KPROC_IDLE;
         goto kreproc;
      }
   break;
   case KPROC_WAITCTRLRELEASED:
      if (!player.keytable[KJUMP])
      {
         player.ctrltimer = 0;
         player.alttimer = 0;
         player.keyprocstate = KPROC_IDLE;
         goto kreproc;
      }
   break;
   case KPROC_WAITALTRELEASED:
      if (!player.keytable[KPOGO])
      {
         player.ctrltimer = 0;
         player.alttimer = 0;
         player.keyprocstate = KPROC_IDLE;
         goto kreproc;
      }
   break;
   }

}

// if player not sliding and not jumping, allow
// them to change their direction. if jumping,
// we can change direction but it will not be shown
// in the frame.
void gamepdo_setdir()
{
int stuck;

   if (player.pfrozentime) return;
   // can't change direction on ice,
   // UNLESS we're stuck up against a wall
   if (player.psliding)
   {
     stuck = 0;
     if (player.pshowdir == LEFT && player.blockedl) stuck = 1;
     if (player.pshowdir == RIGHT && player.blockedr) stuck = 1;
     if (stuck)
     {
       // jumped off an ice block into a wall?
       if (player.pjumping || player.pfalling)
       {
         player.psliding = 0;
       }       
     }
     else
     {
       // since we're not stuck up against a wall, we can't change direction
       return;
     }
   }
  
   if (!player.pjumping && !player.pfiring)
   {
     if (player.keytable[KLEFT]) { player.pdir = player.pshowdir = LEFT; }
     if (player.keytable[KRIGHT]) { player.pdir = player.pshowdir = RIGHT; }
   }
   else
   {
     if (player.keytable[KLEFT]) { player.pdir = LEFT; }
     if (player.keytable[KRIGHT]) { player.pdir = RIGHT; }
   }
}

// set blockedl/r/u...is Keen up against a solid object?
void gamepdo_setblockedlru()
{
int tx,ty;
   player.blockedl = player.blockedr = 0;
   player.blockedu = 0;
   if (levelcontrol.level_done) return;

   if ((player.x>>CSF) < 2) player.blockedl = 1;

      tx = (player.x>>CSF)+4;
      ty = (player.y>>CSF);
      if (tiles[getmaptileat(tx,ty)].solidceil || checkobjsolid(tx<<CSF,ty<<CSF))
      {
          player.blockedu = 1;
          if (tiles[getmaptileat(tx,ty)].bonklethal) killplayer();
      }
      else
      {
         tx = (player.x>>CSF)+12;
         if (tiles[getmaptileat(tx,ty)].solidceil || checkobjsolid(tx<<CSF,ty<<CSF))
         {
            player.blockedu = 1;
            if (tiles[getmaptileat(tx,ty)].bonklethal) killplayer();
         }
      }

       // we use checkissolidl to check for blockedr, and vice versa
       // for blockedl. this is because here we are checking for the
       // right of the player--which will be the left of a potential tile.
      if (checkissolidl((player.x>>CSF)+13, (player.y>>CSF)+1))
         { player.blockedr = 1; }
      else if (checkissolidl((player.x>>CSF)+13, (player.y>>CSF)+8))
         { player.blockedr = 1; }
      else if (checkissolidl((player.x>>CSF)+13, (player.y>>CSF)+16))
         { player.blockedr = 1; }
      else if (checkissolidl((player.x>>CSF)+13, (player.y>>CSF)+23))
         { player.blockedr = 1; }

      // for one-way force fields in ep3, so you can back out if you're
      // not all the way through yet
      if (player.blockedr && tiles[player.blockedby].solidl && !tiles[player.blockedby].solidr)
      {
        if (((player.x>>CSF)+13)>>4<<4 != ((player.x>>CSF)+13))
        {  // not on a tile boundary.
          player.blockedr = 0;
        }
      }
        
      if (checkissolidr((player.x>>CSF)+2, (player.y>>CSF)+1))
         { player.blockedl = 1; }
      else if (checkissolidr((player.x>>CSF)+2, (player.y>>CSF)+8))
         { player.blockedl = 1; }
      else if (checkissolidr((player.x>>CSF)+2, (player.y>>CSF)+16))
         { player.blockedl = 1; }
      else if (checkissolidr((player.x>>CSF)+2, (player.y>>CSF)+23))
         { player.blockedl = 1; }

      if (player.blockedl && tiles[player.blockedby].solidr && !tiles[player.blockedby].solidl)
      {
        if ((((player.x>>CSF)+2)>>4<<4)+15 != ((player.x>>CSF)+2))
        {  // not on a tile boundary.
          player.blockedl = 0;
        }
      }
}

// let's have keen be able to pick up goodies
void gamepdo_getgoodies()
{
   if (tiles[getmaptileat((player.x>>CSF)+9, (player.y>>CSF)+1)].goodie)
      { keen_get_goodie((player.x>>CSF)+9, (player.y>>CSF)+1); return; }
   else if (tiles[getmaptileat((player.x>>CSF)+4, (player.y>>CSF)+8)].goodie)
      { keen_get_goodie((player.x>>CSF)+4, (player.y>>CSF)+8); return; }
   else if (tiles[getmaptileat((player.x>>CSF)+9, (player.y>>CSF)+16)].goodie)
      { keen_get_goodie((player.x>>CSF)+9, (player.y>>CSF)+16); return; }
   else if (tiles[getmaptileat((player.x>>CSF)+4, (player.y>>CSF)+23)].goodie)
      { keen_get_goodie((player.x>>CSF)+4, (player.y>>CSF)+23); }
}

// animation for walking
void gamepdo_walkinganim()
{
    // no walk animation while sliding
    if (player.inhibitwalking || player.psliding) return;

    // should we do walk animation?
    if (player.pwalking || player.playpushed_x)
    {
        // ** do walk animation **
        if (player.pwalkanimtimer > PWALKANIMRATE)
        { // time to change walking frame
          // make walk noise
          if (!player.pjumping && !player.pfalling)
          {
            if (!player.pfrozentime)
            {
               if (player.pwalkframea&1)
                 { sound_play(SOUND_KEEN_WALK, PLAY_NOW); }
               else
                 { sound_play(SOUND_KEEN_WALK2, PLAY_NOW); }
            }
          }
          // increase walk frame and wrap it to 1st frame if needed
          if (player.pwalkframea < 4)
            { player.pwalkframea++; }
          else
            { player.pwalkframea=1; }

          player.pwalkanimtimer = 0;
        }
        else
        {  // did not change walk frame
          player.pwalkanimtimer++;
        }

        // set walk frame: map frame "4" to frame "2", this gives a
        // sequence of 1,2,3,2,1,2,3,2,1,2,3,2....
        if (player.pwalkframea==4)
        {
          player.pwalkframe = 2;
        }
        else
        {
          player.pwalkframe = player.pwalkframea;
        }
    }
}

// handle playpushed_x: for yorps/walkers/etc pushing keen
void gamepdo_playpushed()
{
    // if we're being pushed...
    if (player.playpushed_x)
    {
      // do friction on push force...
      if (player.playpushed_decreasetimer>PLAYPUSH_DECREASERATE)
      {
        // push playpushed_x towards zero
        if (player.playpushed_x < 0)
        {
          player.playpushed_x++;
        }
        else
        {
          player.playpushed_x--;
        }
        player.playpushed_decreasetimer = 0;
      }
      else player.playpushed_decreasetimer++;

      // if we run up against a wall all push inertia stops
      if (player.playpushed_x > 0 && player.blockedr) player.playpushed_x = 0;
      if (player.playpushed_x < 0 && player.blockedl) player.playpushed_x = 0;
    }

}

// handles inertia and friction for the X direction
// (this is where the inertia/playpushed_x is actually applied to playx)
void gamepdo_InertiaAndFriction_X()
{
int friction_rate;

   if (player.hideplayer)
   {
     player.pinertia_x = 0;
     return;
   }
   // don't move when firing
   if (player.pfiring && !player.pjumping && !player.pfalling)
   {
     player.pinertia_x = 0;
   }

   // if we hit a solid object do not move, and keep inertia...
   // * at slow speed: if we're falling or jumping and we're facing
   //                  the right direction, we want to keep
   //                  a small amount of inertia pent up so we can
   //                  easily get into tight spaces.
   // * at zero:       otherwise, or if we're not walking, we want
   //                  to hold the inertia at zero so we don't "shoot"
   //                  off of platforms, etc which looks weird.
   if (!levelcontrol.level_done)
   {
     if (player.pinertia_x < 0 && player.blockedl)
     {
       if (!player.pwalking || (!player.pfalling && !player.pjumping) || player.pdir==RIGHT || (player.pfrozentime&&levelcontrol.episode==1)) player.pinertia_x = 0;
       else if (player.pinertia_x < -PFASTINCMAXSPEED) player.pinertia_x = -PFASTINCMAXSPEED;
       return;
     }
     else if (player.pinertia_x > 0 && player.blockedr)
     {
       if (!player.pwalking || (!player.pfalling && !player.pjumping) || player.pdir==LEFT || (player.pfrozentime&&levelcontrol.episode==1)) player.pinertia_x = 0;
       else if (player.pinertia_x > PFASTINCMAXSPEED) player.pinertia_x = PFASTINCMAXSPEED;
       return;
     }
   }

   // apply pinertia_x and playpushed_x inertia
   // (unless we're about to make a pogo jump)
   if (player.pjumping != PPREPAREPOGO)
   {
     player.x += (player.pinertia_x + player.playpushed_x);
   }

   // if we stopped walking (i.e. left or right not held down) apply friction
   // there's no friction if we're semisliding
   if (!player.keytable[KLEFT] && !player.keytable[KRIGHT] && \
       !player.psemisliding)
   {
     // determine friction rate--different rates for on ground and in air
     if (map.isworldmap)
     {
       friction_rate = PFRICTION_RATE_WM;
     }
     else
     {
        if (!player.pfalling & !player.pjumping)
        {
          friction_rate = PFRICTION_RATE_ONGROUND;
        }
        else
        {
          friction_rate = PFRICTION_RATE_INAIR;
        }
     }

     // and apply friction to pinertia_x
     // when pogoing apply friction till we get down to PFASTINCMAXSPEED
     // then stop the friction
     if (!player.ppogostick || (player.pinertia_x > PFASTINCMAXSPEED) || (player.pinertia_x < -PFASTINCMAXSPEED))
     {
        if (player.pfriction_timer_x > friction_rate)
        {
          if (!player.pfrozentime || levelcontrol.episode!=1)
          {  // disable friction while frozen
             if (player.pinertia_x < 0) player.pinertia_x++;
             else if (player.pinertia_x > 0) player.pinertia_x--;
          }

          player.pfriction_timer_x = 0;
        }
        else player.pfriction_timer_x++;
     }
   }

}

void gamepdo_JumpAndPogo()
{
int mx, my, t, l;
int platx, platy;
signed char pxoff, pyoff;
int o;
int try2;

   // toggle pogo when KPOGO key is pressed
   if (player.isPogo && !player.alreadyPogo && !player.pfrozentime)
   {
       if (levelcontrol.episode==2)
       {
               // if we are at a switch hit the switch instead
               mx = (player.x>>CSF)+8;
               my = (player.y>>CSF)+9;
               try2 = 0;
               retry: ;
               t = getmaptileat(mx, my);
               if (player.ppogostick==0 && (t==TILE_SWITCH_UP || t==TILE_SWITCH_DOWN))
               { // switch to extend platform

                 // figure out where the platform is supposed to extend
                 // (this is coded in the object layer...high byte is the Y offset
                 //  and the low byte is the X offset)
                 l = getlevelat(mx, my);
                 // if zero it's the switch on a tantalus ray!
                 if (l==0)
                 {
                   sound_play(SOUND_SWITCH_TOGGLE, PLAY_NOW);
                   map_chgtile(mx>>4,my>>4,TILE_SWITCH_DOWN);
                   levelcontrol.success = 0;
                   levelcontrol.command = LVLC_TANTALUS_RAY;
                   return;
                 }
                 pxoff = (l & 0x00ff);
                 pyoff = (l & 0xff00) >> 8;
                 platx = (mx >> 4) + pxoff;
                 platy = (my >> 4) + pyoff;

                 if (PlatExtending)       // don't allow player to hit switch again while
                 {                        // plat is moving as this will glitch the plat
                   return;
                 }
                 else PlatExtending = 1;

                 sound_play(SOUND_SWITCH_TOGGLE, PLAY_NOW);

                 if (t==TILE_SWITCH_UP)
                 {  // switch toggled from up to down--extend platform
                   map_chgtile(mx>>4,my>>4,TILE_SWITCH_DOWN);
                   o = spawn_object((mx>>4<<4)<<CSF,(my>>4<<4)<<CSF,OBJ_SECTOREFFECTOR);
                   objects[o].ai.se.type = SE_EXTEND_PLATFORM;
                   objects[o].ai.se.platx = platx;
                   objects[o].ai.se.platy = platy;
                 }
                 else
                 {  // switch toggled from down to up--remove platform
                   map_chgtile(mx>>4,my>>4,TILE_SWITCH_UP);
                   o = spawn_object((mx>>4<<4)<<CSF,(my>>4<<4)<<CSF,OBJ_SECTOREFFECTOR);
                   objects[o].ai.se.type = SE_RETRACT_PLATFORM;
                   objects[o].ai.se.platx = platx;
                   objects[o].ai.se.platy = platy;
                 }     
             }
             else if (player.ppogostick==0 && t==TILE_LIGHTSWITCH)
             { // lightswitch
               levelcontrol.dark ^= 1;
               pal_init(levelcontrol.dark);
               pal_fade(PAL_FADE_SHADES);
               sound_play(SOUND_SWITCH_TOGGLE, PLAY_NOW);
             }
             else
             { // toggle pogo stick
               if (!try2)
               {
                 my = (player.y>>CSF)+1;         
                 try2 = 1;
                 goto retry;
               }
        
               player.ppogostick = 1 - player.ppogostick;
             }
       }
       else
       {        // not episode 2...don't bother with all of this
          if (player.inventory.HasPogo)
          {
            player.ppogostick = 1 - player.ppogostick;
          }
       }
   }

   // handle the JUMP key, both for normal jumps and (high) pogo jumps
   if (!player.pjumping && !player.pfalling && !player.pfiring)
   {
     // give em the chance to jump
     if (player.isJump && !player.ppogostick && !player.pfrozentime)
     {
       player.pjumping = PPREPAREJUMP;
       player.pjumpframe = PPREPAREJUMPFRAME;
       player.pjumpanimtimer = 0;
       player.pwalking = 0;
     }
     else if (player.ppogostick)
     {
       player.pjumping = PPREPAREPOGO;
       player.pjumpanimtimer = 0;
       player.pwalking = 0;
     }
   }

    switch(player.pjumping)
    {
      case PPREPAREPOGO:
          if (player.pjumpanimtimer>PPOGO_PREPARE_TIME)
          {
             // continously bounce while pogo stick is out
             sound_play(SOUND_KEEN_JUMP, PLAY_NOW);
             // jump high if JUMP key down, else bounce low
             if (player.isJump)
             {
               if (!options[OPT_SUPERPOGO].value)
               {  // normal high pogo jump
                  player.pjumpupspeed = PPOGOUP_SPEED;
                  player.pjumptime = PJUMP_NORMALTIME_POGO_LONG;
                  player.pjumpupdecreaserate = PJUMP_UPDECREASERATE_POGO_LONG;
               }
			   else
               {
                  player.pjumpupspeed = PPOGOUP_SPEED_SUPER;
                  player.pjumptime = PJUMP_NORMALTIME_POGO_LONG_SUPER;
                  player.pjumpupdecreaserate = PJUMP_UPDECREASERATE_POGO_LONG_SUPER;                 
               }
             }
             else
             {
               player.pjumpupspeed = PJUMPUP_SPEED;
               player.pjumptime = PJUMP_NORMALTIME_POGO_SHORT;
               player.pjumpupdecreaserate = PJUMP_UPDECREASERATE_POGO_SHORT;
             }
             player.pjumpframe = PJUMP_PREPARE_LAST_FRAME;
             player.pjumping = PPOGOING;
             player.pjumpupspeed_decreasetimer = 0;
             player.pjustjumped = 1;
             if (player.keytable[KLEFT])
                { player.pinertia_x = -PMAXSPEED; player.pdir = player.pshowdir = LEFT; }
             if (player.keytable[KRIGHT])
                { player.pinertia_x = PMAXSPEED; player.pdir = player.pshowdir = RIGHT; }
          } else player.pjumpanimtimer++;
          break;
      case PPREPAREJUMP:
             player.pinertia_x = 0;     // prevent moving while preparing to jump
             if (player.pjumpanimtimer > PJUMP_PREPARE_ANIM_RATE)
             {
                  if (player.pjumpframe == PJUMP_PREPARE_LAST_FRAME || !player.isJump)
                  {  // time to start the jump
                  // select a jump depending on how long keen was preparing
                       player.pjumpupspeed = PJUMPUP_SPEED;
                       switch(player.pjumpframe)
                       {
                       case PPREPAREJUMPFRAME:
                            player.pjumptime = PJUMP_NORMALTIME_6;
                            player.pjumpupdecreaserate = PJUMP_UPDECREASERATE_6;
                            player.pjumpupspeed = 7;
                            break;
                       case PPREPAREJUMPFRAME+1:
                            player.pjumptime = PJUMP_NORMALTIME_5;
                            player.pjumpupdecreaserate = PJUMP_UPDECREASERATE_5;
                            player.pjumpupspeed = 10;
                            break;
					   case PPREPAREJUMPFRAME+2:
                            player.pjumptime = PJUMP_NORMALTIME_4;
                            player.pjumpupdecreaserate = PJUMP_UPDECREASERATE_4;
                            break;
                       case PPREPAREJUMPFRAME+3:
                            player.pjumptime = PJUMP_NORMALTIME_3;
                            player.pjumpupdecreaserate = PJUMP_UPDECREASERATE_3;
                            break;
                       case PPREPAREJUMPFRAME+4:
                            player.pjumptime = PJUMP_NORMALTIME_2;
                            player.pjumpupdecreaserate = PJUMP_UPDECREASERATE_2;
                            break;
                       default:
                            player.pjumptime = PJUMP_NORMALTIME_1;
                            player.pjumpupdecreaserate = PJUMP_UPDECREASERATE_1;
                            break;
                       }
                    player.pjumpframe = PJUMP_PREPARE_LAST_FRAME;

                    sound_play(SOUND_KEEN_JUMP, PLAY_NOW);
                    player.pjumping = PJUMPUP;
                    player.pjumpupspeed_decreasetimer = 0;
                    player.pjustjumped = 1;
                    player.pjumpfloattimer = 0;

                    // make so if we're jumping left or right
                    // the walk code will start at full speed
                    player.pwalking = 1;
                    player.pwalkanimtimer = 0;
                    player.pwalkframe = 1;
                    if (tiles[player.psupportingtile].ice)
                    { // on ice, always jump direction facing
                      if (player.pshowdir==LEFT)
                        { player.pinertia_x = -PMAXSPEED; player.pdir=LEFT; }
                      else
                        { player.pinertia_x = PMAXSPEED; player.pdir=RIGHT; }
                    }
                    else
                    {
                      if (player.keytable[KLEFT])
                        { player.pinertia_x = -PMAXSPEED; player.pdir = player.pshowdir = LEFT; }
                      if (player.keytable[KRIGHT])
                        { player.pinertia_x = PMAXSPEED; player.pdir = player.pshowdir = RIGHT; }
                    }
                    player.pwalkincreasetimer = 0;
                  }
                  else
                  {
                    player.pjumpframe++;
                  }
                  player.pjumpanimtimer=0;
             } else player.pjumpanimtimer++;
             break;
        case PJUMPUP:
        case PPOGOING:
        // check for hitting a ceiling
         if (player.blockedu)   // did we bonk something?
         {  // immediatly abort the jump
            player.pjumping = PNOJUMP;
            sound_play(SOUND_KEEN_BUMPHEAD, PLAY_NOW);
         }
         // do the jump
         if (!player.pjumptime)
         {
           if (player.pjumpupspeed_decreasetimer>player.pjumpupdecreaserate)
           {
              if (!player.pjumpupspeed)
              {
                player.pjumping = PNOJUMP;
              } else player.pjumpupspeed--;
              player.pjumpupspeed_decreasetimer=0;
           } else player.pjumpupspeed_decreasetimer++;
         }
         else player.pjumptime--;
         player.y -= player.pjumpupspeed;
    break;
    }
}

void gamepdo_falling()
{
unsigned int temp;
int objsupport, tilsupport;

    player.pfalling = 0;         // assume not falling

    // do not fall if we're jumping
    if (player.pjumping)
    {
      player.psemisliding = 0;
      return;
    }

    // ** determine if player should fall (nothing solid is beneath him) **

    player.psupportingtile = BG_GRAY;
    player.psupportingobject = 0;
    // test if tile under player is solid; if so set psupportingtile
    objsupport = checkobjsolid(player.x+(4<<CSF), player.y+(sprites[0].ysize<<CSF));
    tilsupport = tiles[getmaptileat((player.x>>CSF)+4, (player.y>>CSF)+sprites[0].ysize)].solidfall;
    if (!tilsupport && !objsupport)
    { // lower-left isn't solid
      objsupport = checkobjsolid(player.x+(12<<CSF), player.y+(sprites[0].ysize<<CSF));
      tilsupport = tiles[getmaptileat((player.x>>CSF)+12, (player.y>>CSF)+sprites[0].ysize)].solidfall;
      if (!tilsupport && !objsupport)
      {  // lower-right isn't solid
         player.pfalling = 1;        // so fall.
         player.pjustfell = 1;
      }
      else
      {  // lower-left isn't solid but lower-right is
        if (!objsupport)
        {
          player.psupportingtile = getmaptileat((player.x>>CSF)+12, (player.y>>CSF)+sprites[0].ysize);
          if (tiles[player.psupportingtile].standgoodie)
          {
            keen_get_goodie((player.x>>CSF)+12, (player.y>>CSF)+sprites[0].ysize);
          }
        }
        else
        {
          player.psupportingtile = PSUPPORTEDBYOBJECT;
          player.psupportingobject = objsupport;
        }
      }
    }
    else
    {   // lower-left is solid
        if (!objsupport)
        {
          player.psupportingtile = getmaptileat((player.x>>CSF)+4, (player.y>>CSF)+sprites[0].ysize);
          if (tiles[player.psupportingtile].standgoodie)
          {
            keen_get_goodie((player.x>>CSF)+4, (player.y>>CSF)+sprites[0].ysize);
          }
        }
        else
        {
          player.psupportingtile = PSUPPORTEDBYOBJECT;
          player.psupportingobject = objsupport;
        }
    }

    // if not on a tile boundary, always fall, prevents being able
    // to land in the middle of a tile.
    if (!player.pfalling && player.psupportingtile!=PSUPPORTEDBYOBJECT)
    {
       temp = (player.y>>CSF)+sprites[0].ysize;    // bottom of player
       if ((temp>>4)<<4 != temp)   // true if it's not a multiple of 16
       {
          player.pfalling = 1;   // not on a tile boundary. fall.
          player.pjustfell = 1;
          player.psupportingtile = BG_GRAY;
          player.psupportingobject = 0;
       }
    }
    // if supported by an object make sure we're at the top of
    // the object else fall
    if (!player.pfalling && player.psupportingtile==PSUPPORTEDBYOBJECT)
    {
       if ((player.y>>CSF)+sprites[0].ysize > (objects[player.psupportingobject].y>>CSF)+4)
       {
          if (!tilsupport)
          {
            player.pfalling = 1;
            player.pjustfell = 1;
            player.psupportingtile = BG_GRAY;
            player.psupportingobject = 0;
          }
       }
    }

    // the first time we land on an object, line us up to be exactly on
    // top of the object
    if (player.psupportingobject && !player.lastsupportingobject)
    {
       player.y = objects[player.psupportingobject].y - (sprites[0].ysize<<CSF);
    }
    player.lastsupportingobject = player.psupportingobject;

    if (player.pfalling)
    {  // nothing solid under player, let's make him fall
       player.psemisliding = 0;

       // just now started falling? (wasn't falling last time)
       if (player.plastfalling == 0)
       {
         // set initial fall speed and make the AAAAAUUUUHHHHH noise
         player.pfallspeed = 1;
         player.pfallspeed_increasetimer = 0;
         if (!player.pjustjumped)
         {
           sound_play(SOUND_KEEN_FALL, PLAY_NOW);
         }
       }

       // gradully increase the fall speed up to maximum rate
       if (player.pfallspeed_increasetimer>PFALL_INCREASERATE)
       {
          if (player.pfallspeed<PFALL_MAXSPEED)
          {
            player.pfallspeed++;
          }
          player.pfallspeed_increasetimer=0;
       } else player.pfallspeed_increasetimer++;

       // add current fall speed to player Y
       player.y += player.pfallspeed;

    }
    else
    {  // not falling

       if (player.plastfalling)
       {  // just now stopped falling
          if (player.pdie != PDIE_FELLOFFMAP)
            sound_stop(SOUND_KEEN_FALL);  // terminate fall noise
          // thud noise
          if (!player.ppogostick) sound_play(SOUND_KEEN_LAND, PLAY_NOW);

          // fix "sliding" effect when you fall, go one way, then
          // before you land turn around and as you hit the ground
          // you're starting to move the other direction
          // (set inertia to 0 if it's contrary to player's current dir)
          if (player.pinertia_x < 0 && player.pshowdir==RIGHT)
            { player.pinertia_x = 0; }
          if (player.pinertia_x > 0 && player.pshowdir==LEFT)
            { player.pinertia_x = 0; }
       }

       // set psliding if we're on ice
       if (tiles[player.psupportingtile].ice)
       {
         player.psliding = 1;
         player.pshowdir = player.pdir;
       }
       else
       {
         player.psliding = 0;
       }
       // set psemisliding if we're on an ice block
       if (tiles[player.psupportingtile].semiice)
       {
         player.psemisliding = 1;
       }
       else
       {
         player.psemisliding = 0;
       }

    }   // close "not falling"

    // save fall state so we can detect the high/low-going edges
    player.plastfalling = player.pfalling;

    // ensure no sliding if we fall or jump off of ice
    if (player.pfalling||player.pjumping) player.psliding=0;
}

// wouldn't it be cool if keen had a raygun, and he could shoot things?
// oh wait, he does, and here's the code for it.
void gamepdo_raygun()
{
int o;
int canRefire;

   if (player.pfireframetimer) player.pfireframetimer--;

   // FIRE button down, and not keencicled?
   if (player.keytable[KFIRE] && !player.pfrozentime)
   {
     player.inhibitwalking = 1;    // prevent moving
     player.pfiring = 1;           // flag that we're firing
     player.ppogostick = 0;        // put away pogo stick if out

     if (!player.lastkeytable[KFIRE] || options[OPT_FULLYAUTOMATIC].value)
     { // fire is newly pressed                   

       // limit how quickly shots can be fired
       if (options[OPT_FULLYAUTOMATIC].value)
       {
         if (player.pfireframetimer < PFIRE_LIMIT_SHOT_FREQ_FA)
         {
           canRefire = 1;
         }
         else canRefire = 0;
       }
       else
       {
         if (player.pfireframetimer < PFIRE_LIMIT_SHOT_FREQ)
         {
           canRefire = 1;
         }
         else canRefire = 0;
       }

       if (canRefire)
       {
          // show raygun for a minimum time even if FIRE is immediatly released
          player.pfireframetimer = PFIRE_SHOWFRAME_TIME;

          // try to fire off a blast
          if (player.inventory.charges)
          {  // we have enough charges

             player.inventory.charges--;
             player.pshowdir = player.pdir;

              sound_play(SOUND_KEEN_FIRE, PLAY_NOW);
              if (player.pdir==RIGHT)
              {  // fire a blast to the right
                 o = spawn_object(player.x+((sprites[0].xsize-4)<<CSF), player.y+(9<<CSF), OBJ_RAY);
                 objects[o].ai.ray.direction = RIGHT;
              }
              else
              {  // fire a blast to the left
                 o = spawn_object(player.x-(12<<CSF), player.y+(9<<CSF), OBJ_RAY);
                 objects[o].ai.ray.direction = LEFT;
              }
          }
          else
          { // oh shit, out of bullets
            // click!
            sound_play(SOUND_GUN_CLICK, PLAY_NOW);
          }  // end "do we have charges?"

       } // end "limit how quickly shots can be fired"

     } // end "fire is newly pressed"
   } // end "fire button down and not keencicled"
   else
   { // FIRE button is NOT down
      // put away ray gun after it's shown for the minimum period of time
      if (!player.pfireframetimer)
      {  // ray gun shown for minimum time
        player.pfiring = 0;
      }
      else
      {  // minimum time not expired
        player.pfiring = 1;
        player.inhibitwalking = 1;
      }
   }

}

// select the appropriate player frame based on what he's doing
void gamepdo_SelectFrame()
{
    player.playframe = 0;      // basic standing

    // select the frame assuming he's pointing right. ep1 does not select
    // a walk frame while fading--this is for the bonus teleporter in L13.
    if (player.pdie) player.playframe = PDIEFRAME + player.pdieframe;
    else if (fade.mode==NO_FADE || levelcontrol.episode!=1 || demomode==DEMO_PLAYBACK)
    {
        if (player.pfrozentime) player.playframe = PFRAME_FROZEN + player.pfrozenframe;
        else if (player.pfiring) player.playframe = PFIREFRAME;
        else if (player.ppogostick) player.playframe = PFRAME_POGO + (player.pjumping==PPREPAREPOGO);
        else if (player.pjumping) player.playframe += player.pjumpframe;
        else if (player.pfalling) player.playframe += 13;
        else if (player.pwalking || player.playpushed_x) player.playframe += player.pwalkframe;
    }

    // if he's going left switch the frame selected above to the
    // appropriate one for the left direction
    if (player.pshowdir && !player.pdie && !player.pfrozentime)
    {
       if (player.pfiring)
       {
          player.playframe++;
       }
       else if (player.ppogostick)
       {
          player.playframe+=2;
       }
       else if (player.pjumping || player.pfalling)
       {
          player.playframe+=6;
       }
       else
       {
          player.playframe+=4;
       }
    }
}

// handles walking. the walking animation is handled by gamepdo_walkinganim()
void gamepdo_walking()
{
int cur_pfastincrate;
    if (player.inhibitwalking && !player.psliding)
    {
      if (!player.pfrozentime||levelcontrol.episode!=1)
        if (!player.pjumping && !player.pfalling)
          player.pinertia_x = 0;
      return;
    }

    // this prevents a "slipping" effect if you jump, say, right, then
    // start walking left just as you hit the ground
    if (player.pjustjumped && ((player.pinertia_x > 0 && player.pdir==LEFT) ||\
                        (player.pinertia_x < 0 && player.pdir==RIGHT)))\
    {
      player.pinertia_x = 0;
	}

    // this code makes it so that if you jump/fall onto a semi-sliding
    // block you'll start moving a little
    if (!player.pjumping && !player.pfalling)
    {
      // on left/right press clear pjustjumped
      if (player.keytable[KLEFT]||player.keytable[KRIGHT])
      {
        player.pjustjumped = 0;
        player.pjustfell = 0;
      }
      // if we fall onto a semislide tile with no inertia
      // start moving a little
      if (player.pjustfell && player.psemisliding)
      {
        if (player.pdir==RIGHT)
        {
          if (player.blockedr)
          {
            player.pjustjumped = 0;
            player.pjustfell = 0;
          }
          else
          {
            if (!player.pinertia_x) player.pinertia_x = 1;
            player.pshowdir = player.pdir;
          }
        }
        else
        {
          if (player.blockedl)
          {
            player.pjustjumped = 0;
            player.pjustfell = 0;
          }
          else
          {
            if (!player.pinertia_x) player.pinertia_x = -1;
            player.pshowdir = player.pdir;
          }
        }
      }
    }

    // test if we're trying to walk
    if ((player.psemisliding&&player.pinertia_x!=0) || ((player.keytable[KLEFT] || player.keytable[KRIGHT] || ((player.keytable[KUP] || player.keytable[KDOWN])&&map.isworldmap)) && !player.inhibitwalking))
    {
      // we just started walking or we changed directions suddenly?
      if (player.pwalking == 0 || ((player.lastpdir==RIGHT && player.pdir==LEFT)||(player.lastpdir==LEFT && player.pdir==RIGHT)))
      {
        player.pwalkanimtimer = 0;
        player.pwalkframe = 1;
        player.pwalkincreasetimer = 0;
        player.pfriction_timer_x = 0;
        player.pfriction_timer_y = 0;
        if (!player.pjumping && !player.pfalling)
        {
          player.pinertia_x = 0;
          player.pinertia_y = 0;
        }
      }
      player.lastpdir = player.pdir;
      player.pwalking = 1;
    }
    else
    {   // end "d-pad down and not sliding"
      player.pwalking = 0;
    }

      /* when sliding on ice force maximum speed */
      if (player.psliding)
      {
         if (player.pjumping != PPREPAREJUMP &&\
             player.pjumping != PPREPAREPOGO)
         {
           // reset walk frame because we have no walk animation while on ice
           player.pwalkframe = 0;
           // keep player sliding at maximum speed
           if (player.pdir==RIGHT)
           {
             player.pinertia_x = PMAXSPEED;
           }
           else if (player.pdir==LEFT)
           {
             player.pinertia_x = -PMAXSPEED;
           }
         }
         return;
      }
      else if (!player.pwalking) return;    // don't run rest of sub if not walking
      // if we get here we're walking and not sliding

      /* increase player inertia while walk key held down */
      if (player.ppogostick)
        cur_pfastincrate = PFASTINCRATE_POGO;
      else
        cur_pfastincrate = PFASTINCRATE;

      if (player.keytable[KRIGHT])
      { // RIGHT key down

          // prevent sliding on map
          if (map.isworldmap && player.pinertia_x < 0) player.pinertia_x = 0;

          // quickly reach PFASTINCMAXSPEED
          if (player.pwalkincreasetimer>=cur_pfastincrate && player.pinertia_x<PFASTINCMAXSPEED)
          {
             player.pinertia_x++;
             player.pwalkincreasetimer=0;
          }
          else
          {
             player.pwalkincreasetimer++;
          }
          // increase up to max speed every time frame is changed
          if (!player.pwalkanimtimer && player.pinertia_x < PMAXSPEED)
          {
             player.pinertia_x++;
          }
      }
      else if (player.keytable[KLEFT])
      {
          // prevent sliding on map
          if (map.isworldmap && player.pinertia_x > 0) player.pinertia_x = 0;

          // quickly reach PFASTINCMAXSPEED
          if (player.pwalkincreasetimer>=cur_pfastincrate && player.pinertia_x>-PFASTINCMAXSPEED)
          {
             player.pinertia_x--;
             player.pwalkincreasetimer=0;
          }
          else
          {
             player.pwalkincreasetimer++;
          }
          // increase up to max speed every time frame is changed
          if (!player.pwalkanimtimer && player.pinertia_x>-PMAXSPEED)
          {
             player.pinertia_x--;
          }
      }

      if (player.keytable[KDOWN])
      {
          if (map.isworldmap && player.pinertia_y < 0) player.pinertia_y = 0;
          // quickly reach PFASTINCMAXSPEED
          if (player.pwalkincreasetimer>=PFASTINCRATE && player.pinertia_y<PFASTINCMAXSPEED)
          {
             player.pinertia_y++;
             player.pwalkincreasetimer=0;
          }
          else
          {
             player.pwalkincreasetimer++;
          }
          // increase up to max speed every time frame is changed
          if (!player.pwalkanimtimer && player.pinertia_y<PMAXSPEED)
          {
             player.pinertia_y++;
          }
      }
      else if (player.keytable[KUP])
      {
          if (map.isworldmap && player.pinertia_y > 0) player.pinertia_y = 0;
          // quickly reach PFASTINCMAXSPEED
          if (player.pwalkincreasetimer>=PFASTINCRATE && player.pinertia_y>-PFASTINCMAXSPEED)
          {
             player.pinertia_y--;
             player.pwalkincreasetimer=0;
          }
          else
          {
             player.pwalkincreasetimer++;
          }
          // increase up to max speed every time frame is changed
          if (!player.pwalkanimtimer && player.pinertia_y>-PMAXSPEED)
          {
             player.pinertia_y--;
          }
      }

}

void gamepdo_ankh()
{
int o;
  if (!player.ankhtime) return;

  o = player.ankhshieldobject;
  objects[o].x = player.x - (8<<CSF);
  objects[o].y = player.y - (8<<CSF);

  player.ankhtime--;
  if (!player.ankhtime)
  {
    objects[o].exists = 0;
  }
  else if (player.ankhtime < ANKH_STAGE3_TIME)
  {
    objects[o].ai.se.state = ANKH_STATE_FLICKERSLOW;
  }
  else if (player.ankhtime < ANKH_STAGE2_TIME)
  {
    objects[o].ai.se.state = ANKH_STATE_FLICKERFAST;
  }
  else
  {
    objects[o].ai.se.state = ANKH_STATE_NOFLICKER;
  }
}

void gamepdo_StatusBox()
{
  if (fade.mode != NO_FADE) return;

  if (player.keytable[KPAUSE] && !player.lastkeytable[KPAUSE])
  {
     showinventory();
  }
}
